package de.hft.stuttgart.citydoctor2.gui.tree;

import de.hft.stuttgart.citydoctor2.zip.CityGmlZipEntry;
import javafx.scene.paint.Color;

public class ZipEntryNode {

    private final CityGmlZipEntry entry;

    public ZipEntryNode(CityGmlZipEntry entry) {
        this.entry = entry;
    }

    public Color getTextColor() {
        if (entry.getErrorType() != null) {
            return Color.RED;
        } else if (entry.isDecompressed()) {
            return Color.GREEN;
        } else {
            return Color.BLACK;
        }
    }

    public String getText() {
        return entry.getDisplayName();
    }

    public CityGmlZipEntry getEntry() {
        return entry;
    }

}
