package de.hft.stuttgart.citydoctor2.healing.math;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import java.util.ArrayList;
import java.util.List;

import org.junit.Test;

import de.hft.stuttgart.citydoctor2.datastructure.Edge;
import de.hft.stuttgart.citydoctor2.datastructure.Vertex;

public class EdgeGraphTest {

	@Test
	public void testGetCycles1() {
		Vertex v0 = new Vertex(4, 4, 0);
		Vertex v1 = new Vertex(4, 4, 4);
		Vertex v2 = new Vertex(0, 4, 4);
		Vertex v3 = new Vertex(0, 4, 0);
		
		Edge e1 = new Edge(v1, v0);
		Edge e2 = new Edge(v1, v2);
		Edge e3 = new Edge(v2, v3);
		
		List<Edge> edges = new ArrayList<>();
		edges.add(e1);
		edges.add(e2);
		edges.add(e3);
		
		EdgeGraph graph = new EdgeGraph();
		graph.addEdge(e1, edges);
		graph.addEdge(e2, edges);
		graph.addEdge(e3, edges);
		
		assertTrue(graph.getCycles().isEmpty());
	}
	
	@Test
	public void testGetCycles2() {
		Vertex v0 = new Vertex(4, 4, 0);
		Vertex v1 = new Vertex(4, 4, 4);
		Vertex v2 = new Vertex(0, 4, 4);
		Vertex v3 = new Vertex(0, 4, 0);
		
		Edge e1 = new Edge(v1, v0);
		Edge e2 = new Edge(v1, v2);
		Edge e3 = new Edge(v2, v3);
		Edge e4 = new Edge(v0, v3);
		
		List<Edge> edges = new ArrayList<>();
		edges.add(e1);
		edges.add(e2);
		edges.add(e3);
		edges.add(e4);
		
		EdgeGraph graph = new EdgeGraph();
		graph.addEdge(e1, edges);
		graph.addEdge(e2, edges);
		graph.addEdge(e3, edges);
		graph.addEdge(e4, edges);
		
		assertFalse(graph.getCycles().isEmpty());
	}

}
